#include "../include/status.h"
#include "../include/string.h"
#include "../include/command.h"

void checkSystemd()
{
	std::vector<std::string> systemctl = splitString(exec("systemctl --state=failed"), '\n');
	std::vector<std::string> failedUnits;
	std::vector<int> vectorService;
	bool foundErrors = false;

	for (unsigned int i{0}; i < systemctl.size(); i++)
	{
		if (findString(systemctl[i],"failed"))
		{
			failedUnits.push_back(systemctl[i]);
			foundErrors = true;
		}
	}

	for (unsigned int i{0}; i < failedUnits.size(); i++)
	{
		vectorService = findDelim(failedUnits[i],' ');
		// Doing math on vectorService to remove the spaces from the name
		failedUnits[i] = stringRange(failedUnits[i],vectorService[0]+1,vectorService[1]-1);
	}

	if (foundErrors == true)
	{
		std::cout << "[FAILED SYSTEMD UNITS]" << std::endl;
		for (unsigned int i{0}; i < failedUnits.size(); i++)
		{
			std::cout << failedUnits[i] << std::endl;
		}
		std::cout << std::endl;
	}
}

void checkDisk()
{
	std::vector<std::string> diskUsage = splitString(exec("df -h"), '\n');
	std::vector<std::string> diskUsageTemp;
	std::vector<std::string> diskPastThreshold;
	bool foundError = false;

	// Iterate over the disks
	for (unsigned int i {1}; i < diskUsage.size(); i++)
	{
		//Split the disks into sections
		diskUsageTemp = splitString(diskUsage[i],' ');
		//Iterate over the split disk
		for (unsigned int x{0}; x < diskUsageTemp.size(); x++)
		{
			//Search the split disk for the percent sign
			if (findString(diskUsageTemp[x],"%") == true)
			{
				//Package up the disks for further use if they are past the threshold
				diskUsageTemp.pop_back();
				// Disk Usage percent is hardcorded for now. Will allow argument passing soon(TM)
				if (std::stoi(diskUsageTemp[x]) >= 50)
				{
					diskPastThreshold.push_back( diskUsageTemp[0] + " " + diskUsageTemp[x] + " " + diskUsageTemp[x+1] );
					foundError = true;
				}
			}
		}
	}

	if (foundError == true)
	{
		std::cout << "[DISK USAGE]" << std::endl;

		for (unsigned int i{0}; i < diskPastThreshold.size(); i++)
		{
			diskUsageTemp = splitString(diskPastThreshold[i],' ');
			std::cout << diskUsageTemp[0] << " " << diskUsageTemp[2] << " " << diskUsageTemp[1] << std::endl;
		}

		std::cout << std::endl;
	}
}
